      subroutine cdftdd(m,n,ncds,ncdspd,ilfunc,icfunc,iminj,icontr,
     &                  inddyy,iloc,g,coord,alphaaux,coeffs,coeffp,
     &                  coeffd,tvec,dmat,zeta,axbx,ayby,azbz,px,py,pz,
     &                  base,pxax,pyay,pzaz,u,zetarec,wxcx,wycy,wzcz,
     &                  wxpx,wypy,wzpz,sss0,sss1,sss2,sss3,sss4,sss5,
     &                  sss6,pss0,pss1,pss2,pss3,pss4,pss5,dss,dss0,
     &                  dss1,dss2,dss3,dss4,fss,fss0,fss1,fss2,fss3,gss,
     &                  gss0,gss1,gss2,psp0,psp1,dsp,dsp0,dsp1,fsp,fsp0,
     &                  fsp1,gsp,gsp0,gsp1,dsd,dsd0,fsd,fsd0,gsd,gsd0,
     &                  dps0,fps0,dds0,dpp,fpp,ddp,dpd,fpd,ddd,zetac1,
     &                  zetac2,c,c1,c2,c3,c4,c5,gather)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension index(36)

      dimension cdfitp(3),cdfitd(6)

      dimension ilfunc(*),icfunc(*),iminj(*),icontr(*),inddyy(m,*),
     &          iloc(*)

      dimension g(*),coord(3,*),alphaaux(*),coeffs(*),coeffp(*),
     &          coeffd(*),tvec(*),dmat(*),zeta(*),axbx(*),ayby(*),
     &          azbz(*),px(*),py(*),pz(*),base(*),pxax(*),pyay(*),
     &          pzaz(*),u(*),zetarec(*),wxcx(*),wycy(*),wzcz(*),wxpx(*),
     &          wypy(*),wzpz(*),sss0(*),sss1(*),sss2(*),sss3(*),sss4(*),
     &          sss5(*),sss6(*),pss0(n,*),pss1(n,*),pss2(n,*),pss3(n,*),
     &          pss4(n,*),pss5(n,*),dss(n,*),dss0(n,*),dss1(n,*),
     &          dss2(n,*),dss3(n,*),dss4(n,*),fss(n,*),fss0(n,*),
     &          fss1(n,*),fss2(n,*),fss3(n,*),gss(n,*),gss0(n,*),
     &          gss1(n,*),gss2(n,*),psp0(n,*),psp1(n,*),dsp(n,*),
     &          dsp0(n,*),dsp1(n,*),fsp(n,*),fsp0(n,*),fsp1(n,*),
     &          gsp(n,*),gsp0(n,*),gsp1(n,*),dsd(n,*),dsd0(n,*),
     &          fsd(n,*),fsd0(n,*),gsd(n,*),gsd0(n,*),dps0(n,*),
     &          fps0(n,*),dds0(n,*),dpp(n,*),fpp(n,*),ddp(n,*),dpd(n,*),
     &          fpd(n,*),ddd(n,*),zetac1(*),zetac2(*),c(*),c1(n,*),
     &          c2(n,*),c3(n,*),c4(n,*),c5(n,*),gather(n,*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,seven/4.0d0,5.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/

      twoecnst=two*pi**(five/two)

      sqrt3=sqrt(three)

      dnormcd=seven/sqrt3

      do 1001 naux=1,ncds

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=coeffs(ilaux)

      do 1002 i=1,n
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      call auggv(5,n,iloc,u,fss0,sss0,sss1,sss2)

      do 1004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,3)/zeta(i)/zetaux
      sss3(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,4)/zeta(i)/zetaux
 1004 sss4(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,5)/zeta(i)/zetaux

      do 1005 i=1,n
 1005 zetac1(i)=zetaux*zetarec(i)

      do 1006 i=1,n
      wxpx(i)=((zeta(i)*px(i)+zetaux*ccx)*zetarec(i))-px(i)
      wypy(i)=((zeta(i)*py(i)+zetaux*ccy)*zetarec(i))-py(i)
 1006 wzpz(i)=((zeta(i)*pz(i)+zetaux*ccz)*zetarec(i))-pz(i)

      do 1007 i=1,n

      pss0(i,1)=pxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=pyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=pzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=pxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=pyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=pzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      pss2(i,1)=pxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=pyay(i)*sss2(i)+wypy(i)*sss3(i)
      pss2(i,3)=pzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      pss3(i,1)=pxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=pyay(i)*sss3(i)+wypy(i)*sss4(i)
      pss3(i,3)=pzaz(i)*sss3(i)+wzpz(i)*sss4(i)

 1007 continue

      do 1008 i=1,n

      c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zeta(i))

      dss0(i,1)=pxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=pyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=pzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=pyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=pzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
      dss0(i,6)=pzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zeta(i))

      dss1(i,1)=pxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=pyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=pzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=pyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=pzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
      dss1(i,6)=pzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zeta(i))

      dss2(i,1)=pxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=pyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=pzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=pyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=pzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
      dss2(i,6)=pzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

 1008 continue

      do 1009 j=1,3
      do 1009 i=1,n
 1009 c1(i,j)=(pss0(i,j)-zetac1(i)*pss1(i,j))/(two*zeta(i))

      do 1010 i=1,n
      fss0(i,01)=pxax(i)*dss0(i,1)+wxpx(i)*dss1(i,1)+c1(i,1)+c1(i,1)
      fss0(i,02)=pyay(i)*dss0(i,1)+wypy(i)*dss1(i,1)
      fss0(i,03)=pzaz(i)*dss0(i,1)+wzpz(i)*dss1(i,1)
      fss0(i,04)=pyay(i)*dss0(i,2)+wypy(i)*dss1(i,2)+c1(i,1)
      fss0(i,05)=pzaz(i)*dss0(i,2)+wzpz(i)*dss1(i,2)
      fss0(i,06)=pzaz(i)*dss0(i,3)+wzpz(i)*dss1(i,3)+c1(i,1)
      fss0(i,07)=pyay(i)*dss0(i,4)+wypy(i)*dss1(i,4)+c1(i,2)+c1(i,2)
      fss0(i,08)=pzaz(i)*dss0(i,4)+wzpz(i)*dss1(i,4)
      fss0(i,09)=pzaz(i)*dss0(i,5)+wzpz(i)*dss1(i,5)+c1(i,2)
 1010 fss0(i,10)=pzaz(i)*dss0(i,6)+wzpz(i)*dss1(i,6)+c1(i,3)+c1(i,3)

      do 1011 j=1,3
      do 1011 i=1,n
 1011 c1(i,j)=(pss1(i,j)-zetac1(i)*pss2(i,j))/(two*zeta(i))

      do 1012 i=1,n
      fss1(i,01)=pxax(i)*dss1(i,1)+wxpx(i)*dss2(i,1)+c1(i,1)+c1(i,1)
      fss1(i,02)=pyay(i)*dss1(i,1)+wypy(i)*dss2(i,1)
      fss1(i,03)=pzaz(i)*dss1(i,1)+wzpz(i)*dss2(i,1)
      fss1(i,04)=pyay(i)*dss1(i,2)+wypy(i)*dss2(i,2)+c1(i,1)
      fss1(i,05)=pzaz(i)*dss1(i,2)+wzpz(i)*dss2(i,2)
      fss1(i,06)=pzaz(i)*dss1(i,3)+wzpz(i)*dss2(i,3)+c1(i,1)
      fss1(i,07)=pyay(i)*dss1(i,4)+wypy(i)*dss2(i,4)+c1(i,2)+c1(i,2)
      fss1(i,08)=pzaz(i)*dss1(i,4)+wzpz(i)*dss2(i,4)
      fss1(i,09)=pzaz(i)*dss1(i,5)+wzpz(i)*dss2(i,5)+c1(i,2)
 1012 fss1(i,10)=pzaz(i)*dss1(i,6)+wzpz(i)*dss2(i,6)+c1(i,3)+c1(i,3)

      do 1013 j=1,6
      do 1013 i=1,n
 1013 c2(i,j)=(dss0(i,j)-zetac1(i)*dss1(i,j))/(two*zeta(i))

      do 1014 i=1,n
      gss0(i,01)=pxax(i)*fss0(i,01)+wxpx(i)*fss1(i,01)+c2(i,1)*three
      gss0(i,02)=pyay(i)*fss0(i,01)+wypy(i)*fss1(i,01)
      gss0(i,03)=pzaz(i)*fss0(i,01)+wzpz(i)*fss1(i,01)
      gss0(i,04)=pyay(i)*fss0(i,02)+wypy(i)*fss1(i,02)+c2(i,1)
      gss0(i,05)=pzaz(i)*fss0(i,02)+wzpz(i)*fss1(i,02)
      gss0(i,06)=pzaz(i)*fss0(i,03)+wzpz(i)*fss1(i,03)+c2(i,1)
      gss0(i,07)=pyay(i)*fss0(i,04)+wypy(i)*fss1(i,04)+c2(i,2)*two
      gss0(i,08)=pzaz(i)*fss0(i,04)+wzpz(i)*fss1(i,04)
      gss0(i,09)=pzaz(i)*fss0(i,05)+wzpz(i)*fss1(i,05)+c2(i,2)
      gss0(i,10)=pzaz(i)*fss0(i,06)+wzpz(i)*fss1(i,06)+c2(i,3)*two
      gss0(i,11)=pyay(i)*fss0(i,07)+wypy(i)*fss1(i,07)+c2(i,4)*three
      gss0(i,12)=pzaz(i)*fss0(i,07)+wzpz(i)*fss1(i,07)
      gss0(i,13)=pzaz(i)*fss0(i,08)+wzpz(i)*fss1(i,08)+c2(i,4)
      gss0(i,14)=pzaz(i)*fss0(i,09)+wzpz(i)*fss1(i,09)+c2(i,5)*two
 1014 gss0(i,15)=pzaz(i)*fss0(i,10)+wzpz(i)*fss1(i,10)+c2(i,6)*three

      do 1015 i=1,n
      dps0(i,01)=axbx(icontr(i))*dss0(i,1)+fss0(i,01)
      dps0(i,02)=ayby(icontr(i))*dss0(i,1)+fss0(i,02)
      dps0(i,03)=azbz(icontr(i))*dss0(i,1)+fss0(i,03)
      dps0(i,04)=axbx(icontr(i))*dss0(i,2)+fss0(i,02)
      dps0(i,05)=ayby(icontr(i))*dss0(i,2)+fss0(i,04)
      dps0(i,06)=azbz(icontr(i))*dss0(i,2)+fss0(i,05)
      dps0(i,07)=axbx(icontr(i))*dss0(i,3)+fss0(i,03)
      dps0(i,08)=ayby(icontr(i))*dss0(i,3)+fss0(i,05)
      dps0(i,09)=azbz(icontr(i))*dss0(i,3)+fss0(i,06)
      dps0(i,10)=axbx(icontr(i))*dss0(i,4)+fss0(i,04)
      dps0(i,11)=ayby(icontr(i))*dss0(i,4)+fss0(i,07)
      dps0(i,12)=azbz(icontr(i))*dss0(i,4)+fss0(i,08)
      dps0(i,13)=axbx(icontr(i))*dss0(i,5)+fss0(i,05)
      dps0(i,14)=ayby(icontr(i))*dss0(i,5)+fss0(i,08)
      dps0(i,15)=azbz(icontr(i))*dss0(i,5)+fss0(i,09)
      dps0(i,16)=axbx(icontr(i))*dss0(i,6)+fss0(i,06)
      dps0(i,17)=ayby(icontr(i))*dss0(i,6)+fss0(i,09)
 1015 dps0(i,18)=azbz(icontr(i))*dss0(i,6)+fss0(i,10)

      do 1016 i=1,n
      fps0(i,01)=axbx(icontr(i))*fss0(i,01)+gss0(i,01)
      fps0(i,02)=ayby(icontr(i))*fss0(i,01)+gss0(i,02)
      fps0(i,03)=azbz(icontr(i))*fss0(i,01)+gss0(i,03)
      fps0(i,04)=axbx(icontr(i))*fss0(i,02)+gss0(i,02)
      fps0(i,05)=ayby(icontr(i))*fss0(i,02)+gss0(i,04)
      fps0(i,06)=azbz(icontr(i))*fss0(i,02)+gss0(i,05)
      fps0(i,07)=axbx(icontr(i))*fss0(i,03)+gss0(i,03)
      fps0(i,08)=ayby(icontr(i))*fss0(i,03)+gss0(i,05)
      fps0(i,09)=azbz(icontr(i))*fss0(i,03)+gss0(i,06)
      fps0(i,10)=axbx(icontr(i))*fss0(i,04)+gss0(i,04)
      fps0(i,11)=ayby(icontr(i))*fss0(i,04)+gss0(i,07)
      fps0(i,12)=azbz(icontr(i))*fss0(i,04)+gss0(i,08)
      fps0(i,13)=axbx(icontr(i))*fss0(i,05)+gss0(i,05)
      fps0(i,14)=ayby(icontr(i))*fss0(i,05)+gss0(i,08)
      fps0(i,15)=azbz(icontr(i))*fss0(i,05)+gss0(i,09)
      fps0(i,16)=axbx(icontr(i))*fss0(i,06)+gss0(i,06)
      fps0(i,17)=ayby(icontr(i))*fss0(i,06)+gss0(i,09)
      fps0(i,18)=azbz(icontr(i))*fss0(i,06)+gss0(i,10)
      fps0(i,19)=axbx(icontr(i))*fss0(i,07)+gss0(i,07)
      fps0(i,20)=ayby(icontr(i))*fss0(i,07)+gss0(i,11)
      fps0(i,21)=azbz(icontr(i))*fss0(i,07)+gss0(i,12)
      fps0(i,22)=axbx(icontr(i))*fss0(i,08)+gss0(i,08)
      fps0(i,23)=ayby(icontr(i))*fss0(i,08)+gss0(i,12)
      fps0(i,24)=azbz(icontr(i))*fss0(i,08)+gss0(i,13)
      fps0(i,25)=axbx(icontr(i))*fss0(i,09)+gss0(i,09)
      fps0(i,26)=ayby(icontr(i))*fss0(i,09)+gss0(i,13)
      fps0(i,27)=azbz(icontr(i))*fss0(i,09)+gss0(i,14)
      fps0(i,28)=axbx(icontr(i))*fss0(i,10)+gss0(i,10)
      fps0(i,29)=ayby(icontr(i))*fss0(i,10)+gss0(i,14)
 1016 fps0(i,30)=azbz(icontr(i))*fss0(i,10)+gss0(i,15)

      do 1017 i=1,n
      dds0(i,01)=axbx(icontr(i))*dps0(i,01)+fps0(i,01)
      dds0(i,02)=ayby(icontr(i))*dps0(i,01)+fps0(i,04)
      dds0(i,03)=azbz(icontr(i))*dps0(i,01)+fps0(i,07)
      dds0(i,04)=ayby(icontr(i))*dps0(i,02)+fps0(i,05)
      dds0(i,05)=azbz(icontr(i))*dps0(i,02)+fps0(i,08)
      dds0(i,06)=azbz(icontr(i))*dps0(i,03)+fps0(i,09)
      dds0(i,07)=axbx(icontr(i))*dps0(i,04)+fps0(i,04)
      dds0(i,08)=ayby(icontr(i))*dps0(i,04)+fps0(i,10)
      dds0(i,09)=azbz(icontr(i))*dps0(i,04)+fps0(i,13)
      dds0(i,10)=ayby(icontr(i))*dps0(i,05)+fps0(i,11)
      dds0(i,11)=azbz(icontr(i))*dps0(i,05)+fps0(i,14)
      dds0(i,12)=azbz(icontr(i))*dps0(i,06)+fps0(i,15)
      dds0(i,13)=axbx(icontr(i))*dps0(i,07)+fps0(i,07)
      dds0(i,14)=ayby(icontr(i))*dps0(i,07)+fps0(i,13)
      dds0(i,15)=azbz(icontr(i))*dps0(i,07)+fps0(i,16)
      dds0(i,16)=ayby(icontr(i))*dps0(i,08)+fps0(i,14)
      dds0(i,17)=azbz(icontr(i))*dps0(i,08)+fps0(i,17)
      dds0(i,18)=azbz(icontr(i))*dps0(i,09)+fps0(i,18)
      dds0(i,19)=axbx(icontr(i))*dps0(i,10)+fps0(i,10)
      dds0(i,20)=ayby(icontr(i))*dps0(i,10)+fps0(i,19)
      dds0(i,21)=azbz(icontr(i))*dps0(i,10)+fps0(i,22)
      dds0(i,22)=ayby(icontr(i))*dps0(i,11)+fps0(i,20)
      dds0(i,23)=azbz(icontr(i))*dps0(i,11)+fps0(i,23)
      dds0(i,24)=azbz(icontr(i))*dps0(i,12)+fps0(i,24)
      dds0(i,25)=axbx(icontr(i))*dps0(i,13)+fps0(i,13)
      dds0(i,26)=ayby(icontr(i))*dps0(i,13)+fps0(i,22)
      dds0(i,27)=azbz(icontr(i))*dps0(i,13)+fps0(i,25)
      dds0(i,28)=ayby(icontr(i))*dps0(i,14)+fps0(i,23)
      dds0(i,29)=azbz(icontr(i))*dps0(i,14)+fps0(i,26)
      dds0(i,30)=azbz(icontr(i))*dps0(i,15)+fps0(i,27)
      dds0(i,31)=axbx(icontr(i))*dps0(i,16)+fps0(i,16)
      dds0(i,32)=ayby(icontr(i))*dps0(i,16)+fps0(i,25)
      dds0(i,33)=azbz(icontr(i))*dps0(i,16)+fps0(i,28)
      dds0(i,34)=ayby(icontr(i))*dps0(i,17)+fps0(i,26)
      dds0(i,35)=azbz(icontr(i))*dps0(i,17)+fps0(i,29)
 1017 dds0(i,36)=azbz(icontr(i))*dps0(i,18)+fps0(i,30)

      do 1018 i=1,n
 1018 gather(i,1)=zero

      do 1019 j=1,36
      do 1019 i=1,n
 1019 gather(i,1)=gather(i,1)+dmat(inddyy(icontr(i),j))*dds0(i,j)

      nnn=0

      do 1020 i=1,n
      if(iminj(icontr(i)).eq.0) then
                                      nnn=nnn+1
                                      iloc(nnn)=i
                                endif
 1020 continue

      index(01)=02
      index(02)=03
      index(03)=04
      index(04)=05
      index(05)=06
      index(06)=09
      index(07)=10
      index(08)=11
      index(09)=12
      index(10)=16
      index(11)=17
      index(12)=18
      index(13)=23
      index(14)=24
      index(15)=30

      do 1021 j=1,15
      do 1021 i=1,nnn
 1021 gather(iloc(i),1)=gather(iloc(i),1)
     &                 -dmat(inddyy(icontr(iloc(i)),index(j)))
     &                 *dds0(iloc(i),index(j))

      do 1022 i=1,n
 1022 gather(i,1)=gather(i,1)*cdfits

      do 1023 i=1,n
 1023 tvec(naux)=tvec(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,ncdspd

      ilaux=ilfunc(ncds+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      cdfits=coeffs(ilaux)

      cdfitp(1)=coeffp(ilaux)
      cdfitp(2)=coeffp(ilaux)
      cdfitp(3)=coeffp(ilaux)

      cdfitd(1)=coeffd(ilaux)/dnormcd
      cdfitd(2)=coeffd(ilaux)
      cdfitd(3)=coeffd(ilaux)
      cdfitd(4)=coeffd(ilaux)/dnormcd
      cdfitd(5)=coeffd(ilaux)
      cdfitd(6)=coeffd(ilaux)/dnormcd

      do 2002 i=1,n
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
      u(i)=zeta(i)*zetaux*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)
 2003 continue

      call auggv(7,n,iloc,u,fss0,sss0,sss1,sss2)

      do 2004 i=1,n
      sss0(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,1)/zeta(i)/zetaux
      sss1(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,2)/zeta(i)/zetaux
      sss2(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,3)/zeta(i)/zetaux
      sss3(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,4)/zeta(i)/zetaux
      sss4(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,5)/zeta(i)/zetaux
      sss5(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,6)/zeta(i)/zetaux
 2004 sss6(i)=base(i)*twoecnst*sqrt(zetarec(i))*fss0(i,7)/zeta(i)/zetaux

      do 2005 i=1,n
      zetac1(i)=zetaux*zetarec(i)
 2005 zetac2(i)=zeta(i)*zetarec(i)

      do 2006 i=1,n
      wxcx(i)=((zeta(i)*px(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zeta(i)*py(i)+zetaux*ccy)*zetarec(i))-ccy
 2006 wzcz(i)=((zeta(i)*pz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 2007 i=1,n
      wxpx(i)=((zeta(i)*px(i)+zetaux*ccx)*zetarec(i))-px(i)
      wypy(i)=((zeta(i)*py(i)+zetaux*ccy)*zetarec(i))-py(i)
 2007 wzpz(i)=((zeta(i)*pz(i)+zetaux*ccz)*zetarec(i))-pz(i)

      do 2008 i=1,n

      pss0(i,1)=pxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=pyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=pzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=pxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=pyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=pzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      pss2(i,1)=pxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=pyay(i)*sss2(i)+wypy(i)*sss3(i)
      pss2(i,3)=pzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      pss3(i,1)=pxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=pyay(i)*sss3(i)+wypy(i)*sss4(i)
      pss3(i,3)=pzaz(i)*sss3(i)+wzpz(i)*sss4(i)

      pss4(i,1)=pxax(i)*sss4(i)+wxpx(i)*sss5(i)
      pss4(i,2)=pyay(i)*sss4(i)+wypy(i)*sss5(i)
      pss4(i,3)=pzaz(i)*sss4(i)+wzpz(i)*sss5(i)

      pss5(i,1)=pxax(i)*sss5(i)+wxpx(i)*sss6(i)
      pss5(i,2)=pyay(i)*sss5(i)+wypy(i)*sss6(i)
      pss5(i,3)=pzaz(i)*sss5(i)+wzpz(i)*sss6(i)

 2008 continue

      do 2009 i=1,n

      c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zeta(i))

      dss0(i,1)=pxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=pyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=pzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=pyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=pzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
      dss0(i,6)=pzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zeta(i))

      dss1(i,1)=pxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=pyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=pzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=pyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=pzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
      dss1(i,6)=pzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zeta(i))

      dss2(i,1)=pxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=pyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=pzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=pyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=pzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
      dss2(i,6)=pzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

      c(i)=(sss3(i)-zetac1(i)*sss4(i))/(two*zeta(i))

      dss3(i,1)=pxax(i)*pss3(i,1)+wxpx(i)*pss4(i,1)+c(i)
      dss3(i,2)=pyay(i)*pss3(i,1)+wypy(i)*pss4(i,1)
      dss3(i,3)=pzaz(i)*pss3(i,1)+wzpz(i)*pss4(i,1)
      dss3(i,4)=pyay(i)*pss3(i,2)+wypy(i)*pss4(i,2)+c(i)
      dss3(i,5)=pzaz(i)*pss3(i,2)+wzpz(i)*pss4(i,2)
      dss3(i,6)=pzaz(i)*pss3(i,3)+wzpz(i)*pss4(i,3)+c(i)

      c(i)=(sss4(i)-zetac1(i)*sss5(i))/(two*zeta(i))

      dss4(i,1)=pxax(i)*pss4(i,1)+wxpx(i)*pss5(i,1)+c(i)
      dss4(i,2)=pyay(i)*pss4(i,1)+wypy(i)*pss5(i,1)
      dss4(i,3)=pzaz(i)*pss4(i,1)+wzpz(i)*pss5(i,1)
      dss4(i,4)=pyay(i)*pss4(i,2)+wypy(i)*pss5(i,2)+c(i)
      dss4(i,5)=pzaz(i)*pss4(i,2)+wzpz(i)*pss5(i,2)
      dss4(i,6)=pzaz(i)*pss4(i,3)+wzpz(i)*pss5(i,3)+c(i)

 2009 continue

      do 2010 j=1,3
      do 2010 i=1,n
 2010 c1(i,j)=(pss0(i,j)-zetac1(i)*pss1(i,j))/(two*zeta(i))

      do 2011 i=1,n
      fss0(i,01)=pxax(i)*dss0(i,1)+wxpx(i)*dss1(i,1)+c1(i,1)+c1(i,1)
      fss0(i,02)=pyay(i)*dss0(i,1)+wypy(i)*dss1(i,1)
      fss0(i,03)=pzaz(i)*dss0(i,1)+wzpz(i)*dss1(i,1)
      fss0(i,04)=pyay(i)*dss0(i,2)+wypy(i)*dss1(i,2)+c1(i,1)
      fss0(i,05)=pzaz(i)*dss0(i,2)+wzpz(i)*dss1(i,2)
      fss0(i,06)=pzaz(i)*dss0(i,3)+wzpz(i)*dss1(i,3)+c1(i,1)
      fss0(i,07)=pyay(i)*dss0(i,4)+wypy(i)*dss1(i,4)+c1(i,2)+c1(i,2)
      fss0(i,08)=pzaz(i)*dss0(i,4)+wzpz(i)*dss1(i,4)
      fss0(i,09)=pzaz(i)*dss0(i,5)+wzpz(i)*dss1(i,5)+c1(i,2)
 2011 fss0(i,10)=pzaz(i)*dss0(i,6)+wzpz(i)*dss1(i,6)+c1(i,3)+c1(i,3)

      do 2012 j=1,3
      do 2012 i=1,n
 2012 c1(i,j)=(pss1(i,j)-zetac1(i)*pss2(i,j))/(two*zeta(i))

      do 2013 i=1,n
      fss1(i,01)=pxax(i)*dss1(i,1)+wxpx(i)*dss2(i,1)+c1(i,1)+c1(i,1)
      fss1(i,02)=pyay(i)*dss1(i,1)+wypy(i)*dss2(i,1)
      fss1(i,03)=pzaz(i)*dss1(i,1)+wzpz(i)*dss2(i,1)
      fss1(i,04)=pyay(i)*dss1(i,2)+wypy(i)*dss2(i,2)+c1(i,1)
      fss1(i,05)=pzaz(i)*dss1(i,2)+wzpz(i)*dss2(i,2)
      fss1(i,06)=pzaz(i)*dss1(i,3)+wzpz(i)*dss2(i,3)+c1(i,1)
      fss1(i,07)=pyay(i)*dss1(i,4)+wypy(i)*dss2(i,4)+c1(i,2)+c1(i,2)
      fss1(i,08)=pzaz(i)*dss1(i,4)+wzpz(i)*dss2(i,4)
      fss1(i,09)=pzaz(i)*dss1(i,5)+wzpz(i)*dss2(i,5)+c1(i,2)
 2013 fss1(i,10)=pzaz(i)*dss1(i,6)+wzpz(i)*dss2(i,6)+c1(i,3)+c1(i,3)

      do 2014 j=1,3
      do 2014 i=1,n
 2014 c1(i,j)=(pss2(i,j)-zetac1(i)*pss3(i,j))/(two*zeta(i))

      do 2015 i=1,n
      fss2(i,01)=pxax(i)*dss2(i,1)+wxpx(i)*dss3(i,1)+c1(i,1)+c1(i,1)
      fss2(i,02)=pyay(i)*dss2(i,1)+wypy(i)*dss3(i,1)
      fss2(i,03)=pzaz(i)*dss2(i,1)+wzpz(i)*dss3(i,1)
      fss2(i,04)=pyay(i)*dss2(i,2)+wypy(i)*dss3(i,2)+c1(i,1)
      fss2(i,05)=pzaz(i)*dss2(i,2)+wzpz(i)*dss3(i,2)
      fss2(i,06)=pzaz(i)*dss2(i,3)+wzpz(i)*dss3(i,3)+c1(i,1)
      fss2(i,07)=pyay(i)*dss2(i,4)+wypy(i)*dss3(i,4)+c1(i,2)+c1(i,2)
      fss2(i,08)=pzaz(i)*dss2(i,4)+wzpz(i)*dss3(i,4)
      fss2(i,09)=pzaz(i)*dss2(i,5)+wzpz(i)*dss3(i,5)+c1(i,2)
 2015 fss2(i,10)=pzaz(i)*dss2(i,6)+wzpz(i)*dss3(i,6)+c1(i,3)+c1(i,3)

      do 2016 j=1,3
      do 2016 i=1,n
 2016 c1(i,j)=(pss3(i,j)-zetac1(i)*pss4(i,j))/(two*zeta(i))

      do 2017 i=1,n
      fss3(i,01)=pxax(i)*dss3(i,1)+wxpx(i)*dss4(i,1)+c1(i,1)+c1(i,1)
      fss3(i,02)=pyay(i)*dss3(i,1)+wypy(i)*dss4(i,1)
      fss3(i,03)=pzaz(i)*dss3(i,1)+wzpz(i)*dss4(i,1)
      fss3(i,04)=pyay(i)*dss3(i,2)+wypy(i)*dss4(i,2)+c1(i,1)
      fss3(i,05)=pzaz(i)*dss3(i,2)+wzpz(i)*dss4(i,2)
      fss3(i,06)=pzaz(i)*dss3(i,3)+wzpz(i)*dss4(i,3)+c1(i,1)
      fss3(i,07)=pyay(i)*dss3(i,4)+wypy(i)*dss4(i,4)+c1(i,2)+c1(i,2)
      fss3(i,08)=pzaz(i)*dss3(i,4)+wzpz(i)*dss4(i,4)
      fss3(i,09)=pzaz(i)*dss3(i,5)+wzpz(i)*dss4(i,5)+c1(i,2)
 2017 fss3(i,10)=pzaz(i)*dss3(i,6)+wzpz(i)*dss4(i,6)+c1(i,3)+c1(i,3)

      do 2018 j=1,6
      do 2018 i=1,n
 2018 c2(i,j)=(dss0(i,j)-zetac1(i)*dss1(i,j))/(two*zeta(i))

      do 2019 i=1,n
      gss0(i,01)=pxax(i)*fss0(i,01)+wxpx(i)*fss1(i,01)+c2(i,1)*three
      gss0(i,02)=pyay(i)*fss0(i,01)+wypy(i)*fss1(i,01)
      gss0(i,03)=pzaz(i)*fss0(i,01)+wzpz(i)*fss1(i,01)
      gss0(i,04)=pyay(i)*fss0(i,02)+wypy(i)*fss1(i,02)+c2(i,1)
      gss0(i,05)=pzaz(i)*fss0(i,02)+wzpz(i)*fss1(i,02)
      gss0(i,06)=pzaz(i)*fss0(i,03)+wzpz(i)*fss1(i,03)+c2(i,1)
      gss0(i,07)=pyay(i)*fss0(i,04)+wypy(i)*fss1(i,04)+c2(i,2)*two
      gss0(i,08)=pzaz(i)*fss0(i,04)+wzpz(i)*fss1(i,04)
      gss0(i,09)=pzaz(i)*fss0(i,05)+wzpz(i)*fss1(i,05)+c2(i,2)
      gss0(i,10)=pzaz(i)*fss0(i,06)+wzpz(i)*fss1(i,06)+c2(i,3)*two
      gss0(i,11)=pyay(i)*fss0(i,07)+wypy(i)*fss1(i,07)+c2(i,4)*three
      gss0(i,12)=pzaz(i)*fss0(i,07)+wzpz(i)*fss1(i,07)
      gss0(i,13)=pzaz(i)*fss0(i,08)+wzpz(i)*fss1(i,08)+c2(i,4)
      gss0(i,14)=pzaz(i)*fss0(i,09)+wzpz(i)*fss1(i,09)+c2(i,5)*two
 2019 gss0(i,15)=pzaz(i)*fss0(i,10)+wzpz(i)*fss1(i,10)+c2(i,6)*three

      do 2020 j=1,6
      do 2020 i=1,n
 2020 c2(i,j)=(dss1(i,j)-zetac1(i)*dss2(i,j))/(two*zeta(i))

      do 2021 i=1,n
      gss1(i,01)=pxax(i)*fss1(i,01)+wxpx(i)*fss2(i,01)+c2(i,1)*three
      gss1(i,02)=pyay(i)*fss1(i,01)+wypy(i)*fss2(i,01)
      gss1(i,03)=pzaz(i)*fss1(i,01)+wzpz(i)*fss2(i,01)
      gss1(i,04)=pyay(i)*fss1(i,02)+wypy(i)*fss2(i,02)+c2(i,1)
      gss1(i,05)=pzaz(i)*fss1(i,02)+wzpz(i)*fss2(i,02)
      gss1(i,06)=pzaz(i)*fss1(i,03)+wzpz(i)*fss2(i,03)+c2(i,1)
      gss1(i,07)=pyay(i)*fss1(i,04)+wypy(i)*fss2(i,04)+c2(i,2)*two
      gss1(i,08)=pzaz(i)*fss1(i,04)+wzpz(i)*fss2(i,04)
      gss1(i,09)=pzaz(i)*fss1(i,05)+wzpz(i)*fss2(i,05)+c2(i,2)
      gss1(i,10)=pzaz(i)*fss1(i,06)+wzpz(i)*fss2(i,06)+c2(i,3)*two
      gss1(i,11)=pyay(i)*fss1(i,07)+wypy(i)*fss2(i,07)+c2(i,4)*three
      gss1(i,12)=pzaz(i)*fss1(i,07)+wzpz(i)*fss2(i,07)
      gss1(i,13)=pzaz(i)*fss1(i,08)+wzpz(i)*fss2(i,08)+c2(i,4)
      gss1(i,14)=pzaz(i)*fss1(i,09)+wzpz(i)*fss2(i,09)+c2(i,5)*two
 2021 gss1(i,15)=pzaz(i)*fss1(i,10)+wzpz(i)*fss2(i,10)+c2(i,6)*three

      do 2022 j=1,6
      do 2022 i=1,n
 2022 c2(i,j)=(dss2(i,j)-zetac1(i)*dss3(i,j))/(two*zeta(i))

      do 2023 i=1,n
      gss2(i,01)=pxax(i)*fss2(i,01)+wxpx(i)*fss3(i,01)+c2(i,1)*three
      gss2(i,02)=pyay(i)*fss2(i,01)+wypy(i)*fss3(i,01)
      gss2(i,03)=pzaz(i)*fss2(i,01)+wzpz(i)*fss3(i,01)
      gss2(i,04)=pyay(i)*fss2(i,02)+wypy(i)*fss3(i,02)+c2(i,1)
      gss2(i,05)=pzaz(i)*fss2(i,02)+wzpz(i)*fss3(i,02)
      gss2(i,06)=pzaz(i)*fss2(i,03)+wzpz(i)*fss3(i,03)+c2(i,1)
      gss2(i,07)=pyay(i)*fss2(i,04)+wypy(i)*fss3(i,04)+c2(i,2)*two
      gss2(i,08)=pzaz(i)*fss2(i,04)+wzpz(i)*fss3(i,04)
      gss2(i,09)=pzaz(i)*fss2(i,05)+wzpz(i)*fss3(i,05)+c2(i,2)
      gss2(i,10)=pzaz(i)*fss2(i,06)+wzpz(i)*fss3(i,06)+c2(i,3)*two
      gss2(i,11)=pyay(i)*fss2(i,07)+wypy(i)*fss3(i,07)+c2(i,4)*three
      gss2(i,12)=pzaz(i)*fss2(i,07)+wzpz(i)*fss3(i,07)
      gss2(i,13)=pzaz(i)*fss2(i,08)+wzpz(i)*fss3(i,08)+c2(i,4)
      gss2(i,14)=pzaz(i)*fss2(i,09)+wzpz(i)*fss3(i,09)+c2(i,5)*two
 2023 gss2(i,15)=pzaz(i)*fss2(i,10)+wzpz(i)*fss3(i,10)+c2(i,6)*three

      do 2024 i=1,n

      c(i)=half*sss1(i)*zetarec(i)

      psp0(i,1)=wxcx(i)*pss1(i,1)+c(i)
      psp0(i,2)=wycy(i)*pss1(i,1)
      psp0(i,3)=wzcz(i)*pss1(i,1)
      psp0(i,4)=wxcx(i)*pss1(i,2)
      psp0(i,5)=wycy(i)*pss1(i,2)+c(i)
      psp0(i,6)=wzcz(i)*pss1(i,2)
      psp0(i,7)=wxcx(i)*pss1(i,3)
      psp0(i,8)=wycy(i)*pss1(i,3)
      psp0(i,9)=wzcz(i)*pss1(i,3)+c(i)

      c(i)=half*sss2(i)*zetarec(i)

      psp1(i,1)=wxcx(i)*pss2(i,1)+c(i)
      psp1(i,2)=wycy(i)*pss2(i,1)
      psp1(i,3)=wzcz(i)*pss2(i,1)
      psp1(i,4)=wxcx(i)*pss2(i,2)
      psp1(i,5)=wycy(i)*pss2(i,2)+c(i)
      psp1(i,6)=wzcz(i)*pss2(i,2)
      psp1(i,7)=wxcx(i)*pss2(i,3)
      psp1(i,8)=wycy(i)*pss2(i,3)
      psp1(i,9)=wzcz(i)*pss2(i,3)+c(i)

 2024 continue

      do 2025 j=1,3
      do 2025 i=1,n
 2025 c1(i,j)=half*pss1(i,j)*zetarec(i)

      do 2026 i=1,n
      dsp0(i,01)=wxcx(i)*dss1(i,1)+c1(i,1)*two
      dsp0(i,02)=wycy(i)*dss1(i,1)
      dsp0(i,03)=wzcz(i)*dss1(i,1)
      dsp0(i,04)=wxcx(i)*dss1(i,2)+c1(i,2)
      dsp0(i,05)=wycy(i)*dss1(i,2)+c1(i,1)
      dsp0(i,06)=wzcz(i)*dss1(i,2)
      dsp0(i,07)=wxcx(i)*dss1(i,3)+c1(i,3)
      dsp0(i,08)=wycy(i)*dss1(i,3)
      dsp0(i,09)=wzcz(i)*dss1(i,3)+c1(i,1)
      dsp0(i,10)=wxcx(i)*dss1(i,4)
      dsp0(i,11)=wycy(i)*dss1(i,4)+c1(i,2)*two
      dsp0(i,12)=wzcz(i)*dss1(i,4)
      dsp0(i,13)=wxcx(i)*dss1(i,5)
      dsp0(i,14)=wycy(i)*dss1(i,5)+c1(i,3)
      dsp0(i,15)=wzcz(i)*dss1(i,5)+c1(i,2)
      dsp0(i,16)=wxcx(i)*dss1(i,6)
      dsp0(i,17)=wycy(i)*dss1(i,6)
 2026 dsp0(i,18)=wzcz(i)*dss1(i,6)+c1(i,3)*two

      do 2027 j=1,3
      do 2027 i=1,n
 2027 c1(i,j)=half*pss2(i,j)*zetarec(i)

      do 2028 i=1,n
      dsp1(i,01)=wxcx(i)*dss2(i,1)+c1(i,1)*two
      dsp1(i,02)=wycy(i)*dss2(i,1)
      dsp1(i,03)=wzcz(i)*dss2(i,1)
      dsp1(i,04)=wxcx(i)*dss2(i,2)+c1(i,2)
      dsp1(i,05)=wycy(i)*dss2(i,2)+c1(i,1)
      dsp1(i,06)=wzcz(i)*dss2(i,2)
      dsp1(i,07)=wxcx(i)*dss2(i,3)+c1(i,3)
      dsp1(i,08)=wycy(i)*dss2(i,3)
      dsp1(i,09)=wzcz(i)*dss2(i,3)+c1(i,1)
      dsp1(i,10)=wxcx(i)*dss2(i,4)
      dsp1(i,11)=wycy(i)*dss2(i,4)+c1(i,2)*two
      dsp1(i,12)=wzcz(i)*dss2(i,4)
      dsp1(i,13)=wxcx(i)*dss2(i,5)
      dsp1(i,14)=wycy(i)*dss2(i,5)+c1(i,3)
      dsp1(i,15)=wzcz(i)*dss2(i,5)+c1(i,2)
      dsp1(i,16)=wxcx(i)*dss2(i,6)
      dsp1(i,17)=wycy(i)*dss2(i,6)
 2028 dsp1(i,18)=wzcz(i)*dss2(i,6)+c1(i,3)*two

      do 2029 j=1,6
      do 2029 i=1,n
 2029 c2(i,j)=half*dss1(i,j)*zetarec(i)

      do 2030 i=1,n
      fsp0(i,01)=wxcx(i)*fss1(i,01)+c2(i,1)*three
      fsp0(i,02)=wycy(i)*fss1(i,01)
      fsp0(i,03)=wzcz(i)*fss1(i,01)
      fsp0(i,04)=wxcx(i)*fss1(i,02)+c2(i,2)*two
      fsp0(i,05)=wycy(i)*fss1(i,02)+c2(i,1)
      fsp0(i,06)=wzcz(i)*fss1(i,02)
      fsp0(i,07)=wxcx(i)*fss1(i,03)+c2(i,3)*two
      fsp0(i,08)=wycy(i)*fss1(i,03)
      fsp0(i,09)=wzcz(i)*fss1(i,03)+c2(i,1)
      fsp0(i,10)=wxcx(i)*fss1(i,04)+c2(i,4)
      fsp0(i,11)=wycy(i)*fss1(i,04)+c2(i,2)*two
      fsp0(i,12)=wzcz(i)*fss1(i,04)
      fsp0(i,13)=wxcx(i)*fss1(i,05)+c2(i,5)
      fsp0(i,14)=wycy(i)*fss1(i,05)+c2(i,3)
      fsp0(i,15)=wzcz(i)*fss1(i,05)+c2(i,2)
      fsp0(i,16)=wxcx(i)*fss1(i,06)+c2(i,6)
      fsp0(i,17)=wycy(i)*fss1(i,06)
      fsp0(i,18)=wzcz(i)*fss1(i,06)+c2(i,3)*two
      fsp0(i,19)=wxcx(i)*fss1(i,07)
      fsp0(i,20)=wycy(i)*fss1(i,07)+c2(i,4)*three
      fsp0(i,21)=wzcz(i)*fss1(i,07)
      fsp0(i,22)=wxcx(i)*fss1(i,08)
      fsp0(i,23)=wycy(i)*fss1(i,08)+c2(i,5)*two
      fsp0(i,24)=wzcz(i)*fss1(i,08)+c2(i,4)
      fsp0(i,25)=wxcx(i)*fss1(i,09)
      fsp0(i,26)=wycy(i)*fss1(i,09)+c2(i,6)
      fsp0(i,27)=wzcz(i)*fss1(i,09)+c2(i,5)*two
      fsp0(i,28)=wxcx(i)*fss1(i,10)
      fsp0(i,29)=wycy(i)*fss1(i,10)
 2030 fsp0(i,30)=wzcz(i)*fss1(i,10)+c2(i,6)*three

      do 2031 j=1,6
      do 2031 i=1,n
 2031 c2(i,j)=half*dss2(i,j)*zetarec(i)

      do 2032 i=1,n
      fsp1(i,01)=wxcx(i)*fss2(i,01)+c2(i,1)*three
      fsp1(i,02)=wycy(i)*fss2(i,01)
      fsp1(i,03)=wzcz(i)*fss2(i,01)
      fsp1(i,04)=wxcx(i)*fss2(i,02)+c2(i,2)*two
      fsp1(i,05)=wycy(i)*fss2(i,02)+c2(i,1)
      fsp1(i,06)=wzcz(i)*fss2(i,02)
      fsp1(i,07)=wxcx(i)*fss2(i,03)+c2(i,3)*two
      fsp1(i,08)=wycy(i)*fss2(i,03)
      fsp1(i,09)=wzcz(i)*fss2(i,03)+c2(i,1)
      fsp1(i,10)=wxcx(i)*fss2(i,04)+c2(i,4)
      fsp1(i,11)=wycy(i)*fss2(i,04)+c2(i,2)*two
      fsp1(i,12)=wzcz(i)*fss2(i,04)
      fsp1(i,13)=wxcx(i)*fss2(i,05)+c2(i,5)
      fsp1(i,14)=wycy(i)*fss2(i,05)+c2(i,3)
      fsp1(i,15)=wzcz(i)*fss2(i,05)+c2(i,2)
      fsp1(i,16)=wxcx(i)*fss2(i,06)+c2(i,6)
      fsp1(i,17)=wycy(i)*fss2(i,06)
      fsp1(i,18)=wzcz(i)*fss2(i,06)+c2(i,3)*two
      fsp1(i,19)=wxcx(i)*fss2(i,07)
      fsp1(i,20)=wycy(i)*fss2(i,07)+c2(i,4)*three
      fsp1(i,21)=wzcz(i)*fss2(i,07)
      fsp1(i,22)=wxcx(i)*fss2(i,08)
      fsp1(i,23)=wycy(i)*fss2(i,08)+c2(i,5)*two
      fsp1(i,24)=wzcz(i)*fss2(i,08)+c2(i,4)
      fsp1(i,25)=wxcx(i)*fss2(i,09)
      fsp1(i,26)=wycy(i)*fss2(i,09)+c2(i,6)
      fsp1(i,27)=wzcz(i)*fss2(i,09)+c2(i,5)*two
      fsp1(i,28)=wxcx(i)*fss2(i,10)
      fsp1(i,29)=wycy(i)*fss2(i,10)
 2032 fsp1(i,30)=wzcz(i)*fss2(i,10)+c2(i,6)*three

      do 2033 j=1,10
      do 2033 i=1,n
 2033 c3(i,j)=half*fss1(i,j)*zetarec(i)

      do 2034 i=1,n
      gsp0(i,01)=wxcx(i)*gss1(i,01)+c3(i,01)*four
      gsp0(i,02)=wycy(i)*gss1(i,01)
      gsp0(i,03)=wzcz(i)*gss1(i,01)
      gsp0(i,04)=wxcx(i)*gss1(i,02)+c3(i,02)*three
      gsp0(i,05)=wycy(i)*gss1(i,02)+c3(i,01)
      gsp0(i,06)=wzcz(i)*gss1(i,02)
      gsp0(i,07)=wxcx(i)*gss1(i,03)+c3(i,03)*three
      gsp0(i,08)=wycy(i)*gss1(i,03)
      gsp0(i,09)=wzcz(i)*gss1(i,03)+c3(i,01)
      gsp0(i,10)=wxcx(i)*gss1(i,04)+c3(i,04)*two
      gsp0(i,11)=wycy(i)*gss1(i,04)+c3(i,02)*two
      gsp0(i,12)=wzcz(i)*gss1(i,04)
      gsp0(i,13)=wxcx(i)*gss1(i,05)+c3(i,05)*two
      gsp0(i,14)=wycy(i)*gss1(i,05)+c3(i,03)
      gsp0(i,15)=wzcz(i)*gss1(i,05)+c3(i,02)
      gsp0(i,16)=wxcx(i)*gss1(i,06)+c3(i,06)*two
      gsp0(i,17)=wycy(i)*gss1(i,06)
      gsp0(i,18)=wzcz(i)*gss1(i,06)+c3(i,03)*two
      gsp0(i,19)=wxcx(i)*gss1(i,07)+c3(i,07)
      gsp0(i,20)=wycy(i)*gss1(i,07)+c3(i,04)*three
      gsp0(i,21)=wzcz(i)*gss1(i,07)
      gsp0(i,22)=wxcx(i)*gss1(i,08)+c3(i,08)
      gsp0(i,23)=wycy(i)*gss1(i,08)+c3(i,05)*two
      gsp0(i,24)=wzcz(i)*gss1(i,08)+c3(i,04)
      gsp0(i,25)=wxcx(i)*gss1(i,09)+c3(i,09)
      gsp0(i,26)=wycy(i)*gss1(i,09)+c3(i,06)
      gsp0(i,27)=wzcz(i)*gss1(i,09)+c3(i,05)*two
      gsp0(i,28)=wxcx(i)*gss1(i,10)+c3(i,10)
      gsp0(i,29)=wycy(i)*gss1(i,10)
      gsp0(i,30)=wzcz(i)*gss1(i,10)+c3(i,06)*three
      gsp0(i,31)=wxcx(i)*gss1(i,11)
      gsp0(i,32)=wycy(i)*gss1(i,11)+c3(i,07)*four
      gsp0(i,33)=wzcz(i)*gss1(i,11)
      gsp0(i,34)=wxcx(i)*gss1(i,12)
      gsp0(i,35)=wycy(i)*gss1(i,12)+c3(i,08)*three
      gsp0(i,36)=wzcz(i)*gss1(i,12)+c3(i,07)
      gsp0(i,37)=wxcx(i)*gss1(i,13)
      gsp0(i,38)=wycy(i)*gss1(i,13)+c3(i,09)*two
      gsp0(i,39)=wzcz(i)*gss1(i,13)+c3(i,08)*two
      gsp0(i,40)=wxcx(i)*gss1(i,14)
      gsp0(i,41)=wycy(i)*gss1(i,14)+c3(i,10)
      gsp0(i,42)=wzcz(i)*gss1(i,14)+c3(i,09)*three
      gsp0(i,43)=wxcx(i)*gss1(i,15)
      gsp0(i,44)=wycy(i)*gss1(i,15)
 2034 gsp0(i,45)=wzcz(i)*gss1(i,15)+c3(i,10)*four

      do 2035 j=1,10
      do 2035 i=1,n
 2035 c3(i,j)=half*fss2(i,j)*zetarec(i)

      do 2036 i=1,n
      gsp1(i,01)=wxcx(i)*gss2(i,01)+c3(i,01)*four
      gsp1(i,02)=wycy(i)*gss2(i,01)
      gsp1(i,03)=wzcz(i)*gss2(i,01)
      gsp1(i,04)=wxcx(i)*gss2(i,02)+c3(i,02)*three
      gsp1(i,05)=wycy(i)*gss2(i,02)+c3(i,01)
      gsp1(i,06)=wzcz(i)*gss2(i,02)
      gsp1(i,07)=wxcx(i)*gss2(i,03)+c3(i,03)*three
      gsp1(i,08)=wycy(i)*gss2(i,03)
      gsp1(i,09)=wzcz(i)*gss2(i,03)+c3(i,01)
      gsp1(i,10)=wxcx(i)*gss2(i,04)+c3(i,04)*two
      gsp1(i,11)=wycy(i)*gss2(i,04)+c3(i,02)*two
      gsp1(i,12)=wzcz(i)*gss2(i,04)
      gsp1(i,13)=wxcx(i)*gss2(i,05)+c3(i,05)*two
      gsp1(i,14)=wycy(i)*gss2(i,05)+c3(i,03)
      gsp1(i,15)=wzcz(i)*gss2(i,05)+c3(i,02)
      gsp1(i,16)=wxcx(i)*gss2(i,06)+c3(i,06)*two
      gsp1(i,17)=wycy(i)*gss2(i,06)
      gsp1(i,18)=wzcz(i)*gss2(i,06)+c3(i,03)*two
      gsp1(i,19)=wxcx(i)*gss2(i,07)+c3(i,07)
      gsp1(i,20)=wycy(i)*gss2(i,07)+c3(i,04)*three
      gsp1(i,21)=wzcz(i)*gss2(i,07)
      gsp1(i,22)=wxcx(i)*gss2(i,08)+c3(i,08)
      gsp1(i,23)=wycy(i)*gss2(i,08)+c3(i,05)*two
      gsp1(i,24)=wzcz(i)*gss2(i,08)+c3(i,04)
      gsp1(i,25)=wxcx(i)*gss2(i,09)+c3(i,09)
      gsp1(i,26)=wycy(i)*gss2(i,09)+c3(i,06)
      gsp1(i,27)=wzcz(i)*gss2(i,09)+c3(i,05)*two
      gsp1(i,28)=wxcx(i)*gss2(i,10)+c3(i,10)
      gsp1(i,29)=wycy(i)*gss2(i,10)
      gsp1(i,30)=wzcz(i)*gss2(i,10)+c3(i,06)*three
      gsp1(i,31)=wxcx(i)*gss2(i,11)
      gsp1(i,32)=wycy(i)*gss2(i,11)+c3(i,07)*four
      gsp1(i,33)=wzcz(i)*gss2(i,11)
      gsp1(i,34)=wxcx(i)*gss2(i,12)
      gsp1(i,35)=wycy(i)*gss2(i,12)+c3(i,08)*three
      gsp1(i,36)=wzcz(i)*gss2(i,12)+c3(i,07)
      gsp1(i,37)=wxcx(i)*gss2(i,13)
      gsp1(i,38)=wycy(i)*gss2(i,13)+c3(i,09)*two
      gsp1(i,39)=wzcz(i)*gss2(i,13)+c3(i,08)*two
      gsp1(i,40)=wxcx(i)*gss2(i,14)
      gsp1(i,41)=wycy(i)*gss2(i,14)+c3(i,10)
      gsp1(i,42)=wzcz(i)*gss2(i,14)+c3(i,09)*three
      gsp1(i,43)=wxcx(i)*gss2(i,15)
      gsp1(i,44)=wycy(i)*gss2(i,15)
 2036 gsp1(i,45)=wzcz(i)*gss2(i,15)+c3(i,10)*four

      do 2037 j=1,6
      do 2037 i=1,n
 2037 c2(i,j)=(dss0(i,j)-zetac2(i)*dss1(i,j))/(two*zetaux)

      do 2038 j=1,9
      do 2038 i=1,n
 2038 c3(i,j)=half*psp1(i,j)*zetarec(i)

      do 2039 i=1,n
      dsd0(i,01)=wxcx(i)*dsp1(i,01)+c2(i,1)+c3(i,1)*two
      dsd0(i,02)=wycy(i)*dsp1(i,01)
      dsd0(i,03)=wzcz(i)*dsp1(i,01)
      dsd0(i,04)=wycy(i)*dsp1(i,02)+c2(i,1)
      dsd0(i,05)=wzcz(i)*dsp1(i,02)
      dsd0(i,06)=wzcz(i)*dsp1(i,03)+c2(i,1)
      dsd0(i,07)=wxcx(i)*dsp1(i,04)+c2(i,2)+c3(i,4)
      dsd0(i,08)=wycy(i)*dsp1(i,04)        +c3(i,1)
      dsd0(i,09)=wzcz(i)*dsp1(i,04)
      dsd0(i,10)=wycy(i)*dsp1(i,05)+c2(i,2)+c3(i,2)
      dsd0(i,11)=wzcz(i)*dsp1(i,05)
      dsd0(i,12)=wzcz(i)*dsp1(i,06)+c2(i,2)
      dsd0(i,13)=wxcx(i)*dsp1(i,07)+c2(i,3)+c3(i,7)
      dsd0(i,14)=wycy(i)*dsp1(i,07)
      dsd0(i,15)=wzcz(i)*dsp1(i,07)        +c3(i,1)
      dsd0(i,16)=wycy(i)*dsp1(i,08)+c2(i,3)
      dsd0(i,17)=wzcz(i)*dsp1(i,08)        +c3(i,2)
      dsd0(i,18)=wzcz(i)*dsp1(i,09)+c2(i,3)+c3(i,3)
      dsd0(i,19)=wxcx(i)*dsp1(i,10)+c2(i,4)
      dsd0(i,20)=wycy(i)*dsp1(i,10)        +c3(i,4)*two
      dsd0(i,21)=wzcz(i)*dsp1(i,10)
      dsd0(i,22)=wycy(i)*dsp1(i,11)+c2(i,4)+c3(i,5)*two
      dsd0(i,23)=wzcz(i)*dsp1(i,11)
      dsd0(i,24)=wzcz(i)*dsp1(i,12)+c2(i,4)
      dsd0(i,25)=wxcx(i)*dsp1(i,13)+c2(i,5)
      dsd0(i,26)=wycy(i)*dsp1(i,13)        +c3(i,7)
      dsd0(i,27)=wzcz(i)*dsp1(i,13)        +c3(i,4)
      dsd0(i,28)=wycy(i)*dsp1(i,14)+c2(i,5)+c3(i,8)
      dsd0(i,29)=wzcz(i)*dsp1(i,14)        +c3(i,5)
      dsd0(i,30)=wzcz(i)*dsp1(i,15)+c2(i,5)+c3(i,6)
      dsd0(i,31)=wxcx(i)*dsp1(i,16)+c2(i,6)
      dsd0(i,32)=wycy(i)*dsp1(i,16)
      dsd0(i,33)=wzcz(i)*dsp1(i,16)        +c3(i,7)*two
      dsd0(i,34)=wycy(i)*dsp1(i,17)+c2(i,6)
      dsd0(i,35)=wzcz(i)*dsp1(i,17)        +c3(i,8)*two
 2039 dsd0(i,36)=wzcz(i)*dsp1(i,18)+c2(i,6)+c3(i,9)*two

      do 2040 j=1,10
      do 2040 i=1,n
 2040 c4(i,j)=(fss0(i,j)-zetac2(i)*fss1(i,j))/(two*zetaux)

      do 2041 j=1,18
      do 2041 i=1,n
 2041 c5(i,j)=half*dsp1(i,j)*zetarec(i)

      do 2042 i=1,n
      fsd0(i,01)=wxcx(i)*fsp1(i,01)+c4(i,01)+c5(i,01)*three
      fsd0(i,02)=wycy(i)*fsp1(i,01)
      fsd0(i,03)=wzcz(i)*fsp1(i,01)
      fsd0(i,04)=wycy(i)*fsp1(i,02)+c4(i,01)
      fsd0(i,05)=wzcz(i)*fsp1(i,02)
      fsd0(i,06)=wzcz(i)*fsp1(i,03)+c4(i,01)
      fsd0(i,07)=wxcx(i)*fsp1(i,04)+c4(i,02)+c5(i,04)*two
      fsd0(i,08)=wycy(i)*fsp1(i,04)         +c5(i,01)
      fsd0(i,09)=wzcz(i)*fsp1(i,04)
      fsd0(i,10)=wycy(i)*fsp1(i,05)+c4(i,02)+c5(i,02)
      fsd0(i,11)=wzcz(i)*fsp1(i,05)
      fsd0(i,12)=wzcz(i)*fsp1(i,06)+c4(i,02)
      fsd0(i,13)=wxcx(i)*fsp1(i,07)+c4(i,03)+c5(i,07)*two
      fsd0(i,14)=wycy(i)*fsp1(i,07)
      fsd0(i,15)=wzcz(i)*fsp1(i,07)         +c5(i,01)
      fsd0(i,16)=wycy(i)*fsp1(i,08)+c4(i,03)
      fsd0(i,17)=wzcz(i)*fsp1(i,08)         +c5(i,02)
      fsd0(i,18)=wzcz(i)*fsp1(i,09)+c4(i,03)+c5(i,03)
      fsd0(i,19)=wxcx(i)*fsp1(i,10)+c4(i,04)+c5(i,10)
      fsd0(i,20)=wycy(i)*fsp1(i,10)         +c5(i,04)*two
      fsd0(i,21)=wzcz(i)*fsp1(i,10)
      fsd0(i,22)=wycy(i)*fsp1(i,11)+c4(i,04)+c5(i,05)*two
      fsd0(i,23)=wzcz(i)*fsp1(i,11)
      fsd0(i,24)=wzcz(i)*fsp1(i,12)+c4(i,04)
      fsd0(i,25)=wxcx(i)*fsp1(i,13)+c4(i,05)+c5(i,13)
      fsd0(i,26)=wycy(i)*fsp1(i,13)         +c5(i,07)
      fsd0(i,27)=wzcz(i)*fsp1(i,13)         +c5(i,04)
      fsd0(i,28)=wycy(i)*fsp1(i,14)+c4(i,05)+c5(i,08)
      fsd0(i,29)=wzcz(i)*fsp1(i,14)         +c5(i,05)
      fsd0(i,30)=wzcz(i)*fsp1(i,15)+c4(i,05)+c5(i,06)
      fsd0(i,31)=wxcx(i)*fsp1(i,16)+c4(i,06)+c5(i,16)
      fsd0(i,32)=wycy(i)*fsp1(i,16)
      fsd0(i,33)=wzcz(i)*fsp1(i,16)         +c5(i,07)*two
      fsd0(i,34)=wycy(i)*fsp1(i,17)+c4(i,06)
      fsd0(i,35)=wzcz(i)*fsp1(i,17)         +c5(i,08)*two
      fsd0(i,36)=wzcz(i)*fsp1(i,18)+c4(i,06)+c5(i,09)*two
      fsd0(i,37)=wxcx(i)*fsp1(i,19)+c4(i,07)
      fsd0(i,38)=wycy(i)*fsp1(i,19)         +c5(i,10)*three
      fsd0(i,39)=wzcz(i)*fsp1(i,19)
      fsd0(i,40)=wycy(i)*fsp1(i,20)+c4(i,07)+c5(i,11)*three
      fsd0(i,41)=wzcz(i)*fsp1(i,20)
      fsd0(i,42)=wzcz(i)*fsp1(i,21)+c4(i,07)
      fsd0(i,43)=wxcx(i)*fsp1(i,22)+c4(i,08)
      fsd0(i,44)=wycy(i)*fsp1(i,22)         +c5(i,13)*two
      fsd0(i,45)=wzcz(i)*fsp1(i,22)         +c5(i,10)
      fsd0(i,46)=wycy(i)*fsp1(i,23)+c4(i,08)+c5(i,14)*two
      fsd0(i,47)=wzcz(i)*fsp1(i,23)         +c5(i,11)
      fsd0(i,48)=wzcz(i)*fsp1(i,24)+c4(i,08)+c5(i,12)
      fsd0(i,49)=wxcx(i)*fsp1(i,25)+c4(i,09)
      fsd0(i,50)=wycy(i)*fsp1(i,25)         +c5(i,16)
      fsd0(i,51)=wzcz(i)*fsp1(i,25)         +c5(i,13)*two
      fsd0(i,52)=wycy(i)*fsp1(i,26)+c4(i,09)+c5(i,17)
      fsd0(i,53)=wzcz(i)*fsp1(i,26)         +c5(i,14)*two
      fsd0(i,54)=wzcz(i)*fsp1(i,27)+c4(i,09)+c5(i,15)*two
      fsd0(i,55)=wxcx(i)*fsp1(i,28)+c4(i,10)
      fsd0(i,56)=wycy(i)*fsp1(i,28)
      fsd0(i,57)=wzcz(i)*fsp1(i,28)         +c5(i,16)*three
      fsd0(i,58)=wycy(i)*fsp1(i,29)+c4(i,10)
      fsd0(i,59)=wzcz(i)*fsp1(i,29)         +c5(i,17)*three
 2042 fsd0(i,60)=wzcz(i)*fsp1(i,30)+c4(i,10)+c5(i,18)*three

      do 2043 j=1,15
      do 2043 i=1,n
 2043 c4(i,j)=(gss0(i,j)-zetac2(i)*gss1(i,j))/(two*zetaux)

      do 2044 j=1,30
      do 2044 i=1,n
 2044 c5(i,j)=half*fsp1(i,j)*zetarec(i)

      do 2045 i=1,n
      gsd0(i,01)=wxcx(i)*gsp1(i,01)+c4(i,01)+c5(i,01)*four
      gsd0(i,02)=wycy(i)*gsp1(i,01)
      gsd0(i,03)=wzcz(i)*gsp1(i,01)
      gsd0(i,04)=wycy(i)*gsp1(i,02)+c4(i,01)
      gsd0(i,05)=wzcz(i)*gsp1(i,02)
      gsd0(i,06)=wzcz(i)*gsp1(i,03)+c4(i,01)
      gsd0(i,07)=wxcx(i)*gsp1(i,04)+c4(i,02)+c5(i,04)*three
      gsd0(i,08)=wycy(i)*gsp1(i,04)         +c5(i,01)
      gsd0(i,09)=wzcz(i)*gsp1(i,04)
      gsd0(i,10)=wycy(i)*gsp1(i,05)+c4(i,02)+c5(i,02)
      gsd0(i,11)=wzcz(i)*gsp1(i,05)
      gsd0(i,12)=wzcz(i)*gsp1(i,06)+c4(i,02)
      gsd0(i,13)=wxcx(i)*gsp1(i,07)+c4(i,03)+c5(i,07)*three
      gsd0(i,14)=wycy(i)*gsp1(i,07)
      gsd0(i,15)=wzcz(i)*gsp1(i,07)         +c5(i,01)
      gsd0(i,16)=wycy(i)*gsp1(i,08)+c4(i,03)
      gsd0(i,17)=wzcz(i)*gsp1(i,08)         +c5(i,02)
      gsd0(i,18)=wzcz(i)*gsp1(i,09)+c4(i,03)+c5(i,03)
      gsd0(i,19)=wxcx(i)*gsp1(i,10)+c4(i,04)+c5(i,10)*two
      gsd0(i,20)=wycy(i)*gsp1(i,10)         +c5(i,04)*two
      gsd0(i,21)=wzcz(i)*gsp1(i,10)
      gsd0(i,22)=wycy(i)*gsp1(i,11)+c4(i,04)+c5(i,05)*two
      gsd0(i,23)=wzcz(i)*gsp1(i,11)
      gsd0(i,24)=wzcz(i)*gsp1(i,12)+c4(i,04)
      gsd0(i,25)=wxcx(i)*gsp1(i,13)+c4(i,05)+c5(i,13)*two
      gsd0(i,26)=wycy(i)*gsp1(i,13)         +c5(i,07)
      gsd0(i,27)=wzcz(i)*gsp1(i,13)         +c5(i,04)
      gsd0(i,28)=wycy(i)*gsp1(i,14)+c4(i,05)+c5(i,08)
      gsd0(i,29)=wzcz(i)*gsp1(i,14)         +c5(i,05)
      gsd0(i,30)=wzcz(i)*gsp1(i,15)+c4(i,05)+c5(i,06)
      gsd0(i,31)=wxcx(i)*gsp1(i,16)+c4(i,06)+c5(i,16)*two
      gsd0(i,32)=wycy(i)*gsp1(i,16)
      gsd0(i,33)=wzcz(i)*gsp1(i,16)         +c5(i,07)*two
      gsd0(i,34)=wycy(i)*gsp1(i,17)+c4(i,06)
      gsd0(i,35)=wzcz(i)*gsp1(i,17)         +c5(i,08)*two
      gsd0(i,36)=wzcz(i)*gsp1(i,18)+c4(i,06)+c5(i,09)*two
      gsd0(i,37)=wxcx(i)*gsp1(i,19)+c4(i,07)+c5(i,19)
      gsd0(i,38)=wycy(i)*gsp1(i,19)         +c5(i,10)*three
      gsd0(i,39)=wzcz(i)*gsp1(i,19)
      gsd0(i,40)=wycy(i)*gsp1(i,20)+c4(i,07)+c5(i,11)*three
      gsd0(i,41)=wzcz(i)*gsp1(i,20)
      gsd0(i,42)=wzcz(i)*gsp1(i,21)+c4(i,07)
      gsd0(i,43)=wxcx(i)*gsp1(i,22)+c4(i,08)+c5(i,22)
      gsd0(i,44)=wycy(i)*gsp1(i,22)         +c5(i,13)*two
      gsd0(i,45)=wzcz(i)*gsp1(i,22)         +c5(i,10)
      gsd0(i,46)=wycy(i)*gsp1(i,23)+c4(i,08)+c5(i,14)*two
      gsd0(i,47)=wzcz(i)*gsp1(i,23)         +c5(i,11)
      gsd0(i,48)=wzcz(i)*gsp1(i,24)+c4(i,08)+c5(i,12)
      gsd0(i,49)=wxcx(i)*gsp1(i,25)+c4(i,09)+c5(i,25)
      gsd0(i,50)=wycy(i)*gsp1(i,25)         +c5(i,16)
      gsd0(i,51)=wzcz(i)*gsp1(i,25)         +c5(i,13)*two
      gsd0(i,52)=wycy(i)*gsp1(i,26)+c4(i,09)+c5(i,17)
      gsd0(i,53)=wzcz(i)*gsp1(i,26)         +c5(i,14)*two
      gsd0(i,54)=wzcz(i)*gsp1(i,27)+c4(i,09)+c5(i,15)*two
      gsd0(i,55)=wxcx(i)*gsp1(i,28)+c4(i,10)+c5(i,28)
      gsd0(i,56)=wycy(i)*gsp1(i,28)
      gsd0(i,57)=wzcz(i)*gsp1(i,28)         +c5(i,16)*three
      gsd0(i,58)=wycy(i)*gsp1(i,29)+c4(i,10)
      gsd0(i,59)=wzcz(i)*gsp1(i,29)         +c5(i,17)*three
      gsd0(i,60)=wzcz(i)*gsp1(i,30)+c4(i,10)+c5(i,18)*three
      gsd0(i,61)=wxcx(i)*gsp1(i,31)+c4(i,11)
      gsd0(i,62)=wycy(i)*gsp1(i,31)         +c5(i,19)*four
      gsd0(i,63)=wzcz(i)*gsp1(i,31)
      gsd0(i,64)=wycy(i)*gsp1(i,32)+c4(i,11)+c5(i,20)*four
      gsd0(i,65)=wzcz(i)*gsp1(i,32)
      gsd0(i,66)=wzcz(i)*gsp1(i,33)+c4(i,11)
      gsd0(i,67)=wxcx(i)*gsp1(i,34)+c4(i,12)
      gsd0(i,68)=wycy(i)*gsp1(i,34)         +c5(i,22)*three
      gsd0(i,69)=wzcz(i)*gsp1(i,34)         +c5(i,19)
      gsd0(i,70)=wycy(i)*gsp1(i,35)+c4(i,12)+c5(i,23)*three
      gsd0(i,71)=wzcz(i)*gsp1(i,35)         +c5(i,20)
      gsd0(i,72)=wzcz(i)*gsp1(i,36)+c4(i,12)+c5(i,21)
      gsd0(i,73)=wxcx(i)*gsp1(i,37)+c4(i,13)
      gsd0(i,74)=wycy(i)*gsp1(i,37)         +c5(i,25)*two
      gsd0(i,75)=wzcz(i)*gsp1(i,37)         +c5(i,22)*two
      gsd0(i,76)=wycy(i)*gsp1(i,38)+c4(i,13)+c5(i,26)*two
      gsd0(i,77)=wzcz(i)*gsp1(i,38)         +c5(i,23)*two
      gsd0(i,78)=wzcz(i)*gsp1(i,39)+c4(i,13)+c5(i,24)*two
      gsd0(i,79)=wxcx(i)*gsp1(i,40)+c4(i,14)
      gsd0(i,80)=wycy(i)*gsp1(i,40)         +c5(i,28)
      gsd0(i,81)=wzcz(i)*gsp1(i,40)         +c5(i,25)*three
      gsd0(i,82)=wycy(i)*gsp1(i,41)+c4(i,14)+c5(i,29)
      gsd0(i,83)=wzcz(i)*gsp1(i,41)         +c5(i,26)*three
      gsd0(i,84)=wzcz(i)*gsp1(i,42)+c4(i,14)+c5(i,27)*three
      gsd0(i,85)=wxcx(i)*gsp1(i,43)+c4(i,15)
      gsd0(i,86)=wycy(i)*gsp1(i,43)
      gsd0(i,87)=wzcz(i)*gsp1(i,43)         +c5(i,28)*four
      gsd0(i,88)=wycy(i)*gsp1(i,44)+c4(i,15)
      gsd0(i,89)=wzcz(i)*gsp1(i,44)         +c5(i,29)*four
 2045 gsd0(i,90)=wzcz(i)*gsp1(i,45)+c4(i,15)+c5(i,30)*four

      call cdftdd1(m,n,icontr,axbx,ayby,azbz,dss0,fss0,gss0,dsp0,fsp0,
     &             gsp0,dsd0,fsd0,gsd0,dps0,fps0,dds0,dpp,fpp,ddp,dpd,
     &             fpd,ddd)

      call cdftdd2(m,n,ncds,naux,iminj,icontr,inddyy,iloc,cdfits,
     &             cdfitp,cdfitd,tvec,dmat,dds0,ddp,ddd,gather)

 2001 continue

      return
      end
