      subroutine fards(m,n,natoms,icontr,inddyy,iloc,itemp,g,coord,
     &                 redfit,fock,zeta,px,py,pz,base,pxax,pyay,pzaz,u,
     &                 zetarec,wxcx,wycy,wzcz,wxpx,wypy,wzpz,sss0,sss1,
     &                 sss2,sss3,sss4,pss0,pss1,pss2,pss3,dss,dss0,dss1,
     &                 dss2,psp1,dsp,dsp0,dsp1,dsd,dsd0,zetac1,zetac2,c,
     &                 c1,c2,c3,zzeta,ppx,ppy,ppz,ppxax,ppyay,ppzaz,
     &                 gather,extent)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension cdfitp(3),cdfitd(6)

      dimension icontr(*),inddyy(m,*),iloc(*),itemp(*)

      dimension g(*),coord(3,*),redfit(10,*),fock(*),zeta(*),px(*),
     &          py(*),pz(*),base(*),pxax(*),pyay(*),pzaz(*),u(*),
     &          zetarec(*),wxcx(*),wycy(*),wzcz(*),wxpx(*),wypy(*),
     &          wzpz(*),sss0(*),sss1(*),sss2(*),sss3(*),sss4(*),
     &          pss0(n,*),pss1(n,*),pss2(n,*),pss3(n,*),dss(m,*),
     &          dss0(n,*),dss1(n,*),dss2(n,*),psp1(n,*),dsp(m,*),
     &          dsp0(n,*),dsp1(n,*),dsd(m,*),dsd0(n,*),zetac1(*),
     &          zetac2(*),c(*),c1(n,*),c2(n,*),c3(n,*),zzeta(*),ppx(*),
     &          ppy(*),ppz(*),ppxax(*),ppyay(*),ppzaz(*),gather(n,*),
     &          extent(*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,six,seven/4.0d0,5.0d0,6.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/
      data rmultipole,onethousand/16.7d0,1000.0d0/
      data cs,cp,cd/1130.5901d0,123849.94d0,10112305.0d0/

      twoecnst=two*pi**(five/two)

      sqrt3=sqrt(three)

      dnormcd=seven/sqrt3

      do 1001 iatom=1,natoms

      ccx=coord(1,iatom)
      ccy=coord(2,iatom)
      ccz=coord(3,iatom)

      zetaux=onethousand

      cdfits=redfit(01,iatom)*cs

      cdfitp(1)=redfit(02,iatom)*cp
      cdfitp(2)=redfit(03,iatom)*cp
      cdfitp(3)=redfit(04,iatom)*cp

      cdfitd(1)=redfit(05,iatom)*cd/dnormcd
      cdfitd(2)=redfit(06,iatom)*cd
      cdfitd(3)=redfit(07,iatom)*cd
      cdfitd(4)=redfit(08,iatom)*cd/dnormcd
      cdfitd(5)=redfit(09,iatom)*cd
      cdfitd(6)=redfit(10,iatom)*cd/dnormcd

      nn=0

      do 1002 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
      pc=pxcx*pxcx+pycy*pycy+pzcz*pzcz
      if(extent(i).le.pc) then
                                 nn=nn+1

                                 zetarec(nn)=one/(zeta(i)+zetaux)

                                 u(nn)=zetaux*zetarec(nn)*zeta(i)*pc

                                 iloc(nn)=i

                                 zzeta(nn)=zeta(i)

                                 ppx(nn)=px(i)
                                 ppy(nn)=py(i)
                                 ppz(nn)=pz(i)

                                 ppxax(nn)=pxax(i)
                                 ppyay(nn)=pyay(i)
                                 ppzaz(nn)=pzaz(i)
                          endif
 1002 continue

      if(nn.eq.0) goto 1001

      call auggnew(5,nn,n,itemp,u,psp1,wxcx,wycy,wzcz)

      factor=twoecnst/zetaux

      do 1003 i=1,nn
 1003 c(i)=base(iloc(i))*factor*sqrt(zetarec(i))/zzeta(i)

      do 1004 i=1,nn
      sss0(i)=c(i)*psp1(i,1)
      sss1(i)=c(i)*psp1(i,2)
      sss2(i)=c(i)*psp1(i,3)
      sss3(i)=c(i)*psp1(i,4)
 1004 sss4(i)=c(i)*psp1(i,5)

      do 1005 i=1,nn
      zetac1(i)=zetaux*zetarec(i)
 1005 zetac2(i)=zzeta(i)*zetarec(i)

      do 1006 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 1006 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 1007 i=1,nn
      wxpx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ppx(i)
      wypy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ppy(i)
 1007 wzpz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ppz(i)

      do 1008 i=1,nn

      pss0(i,1)=ppxax(i)*sss0(i)+wxpx(i)*sss1(i)
      pss0(i,2)=ppyay(i)*sss0(i)+wypy(i)*sss1(i)
      pss0(i,3)=ppzaz(i)*sss0(i)+wzpz(i)*sss1(i)

      pss1(i,1)=ppxax(i)*sss1(i)+wxpx(i)*sss2(i)
      pss1(i,2)=ppyay(i)*sss1(i)+wypy(i)*sss2(i)
      pss1(i,3)=ppzaz(i)*sss1(i)+wzpz(i)*sss2(i)

      pss2(i,1)=ppxax(i)*sss2(i)+wxpx(i)*sss3(i)
      pss2(i,2)=ppyay(i)*sss2(i)+wypy(i)*sss3(i)
      pss2(i,3)=ppzaz(i)*sss2(i)+wzpz(i)*sss3(i)

      pss3(i,1)=ppxax(i)*sss3(i)+wxpx(i)*sss4(i)
      pss3(i,2)=ppyay(i)*sss3(i)+wypy(i)*sss4(i)
      pss3(i,3)=ppzaz(i)*sss3(i)+wzpz(i)*sss4(i)

 1008 continue

      do 1009 i=1,nn

      c(i)=(sss0(i)-zetac1(i)*sss1(i))/(two*zzeta(i))

      dss0(i,1)=ppxax(i)*pss0(i,1)+wxpx(i)*pss1(i,1)+c(i)
      dss0(i,2)=ppyay(i)*pss0(i,1)+wypy(i)*pss1(i,1)
      dss0(i,3)=ppzaz(i)*pss0(i,1)+wzpz(i)*pss1(i,1)
      dss0(i,4)=ppyay(i)*pss0(i,2)+wypy(i)*pss1(i,2)+c(i)
      dss0(i,5)=ppzaz(i)*pss0(i,2)+wzpz(i)*pss1(i,2)
      dss0(i,6)=ppzaz(i)*pss0(i,3)+wzpz(i)*pss1(i,3)+c(i)

      c(i)=(sss1(i)-zetac1(i)*sss2(i))/(two*zzeta(i))

      dss1(i,1)=ppxax(i)*pss1(i,1)+wxpx(i)*pss2(i,1)+c(i)
      dss1(i,2)=ppyay(i)*pss1(i,1)+wypy(i)*pss2(i,1)
      dss1(i,3)=ppzaz(i)*pss1(i,1)+wzpz(i)*pss2(i,1)
      dss1(i,4)=ppyay(i)*pss1(i,2)+wypy(i)*pss2(i,2)+c(i)
      dss1(i,5)=ppzaz(i)*pss1(i,2)+wzpz(i)*pss2(i,2)
      dss1(i,6)=ppzaz(i)*pss1(i,3)+wzpz(i)*pss2(i,3)+c(i)

      c(i)=(sss2(i)-zetac1(i)*sss3(i))/(two*zzeta(i))

      dss2(i,1)=ppxax(i)*pss2(i,1)+wxpx(i)*pss3(i,1)+c(i)
      dss2(i,2)=ppyay(i)*pss2(i,1)+wypy(i)*pss3(i,1)
      dss2(i,3)=ppzaz(i)*pss2(i,1)+wzpz(i)*pss3(i,1)
      dss2(i,4)=ppyay(i)*pss2(i,2)+wypy(i)*pss3(i,2)+c(i)
      dss2(i,5)=ppzaz(i)*pss2(i,2)+wzpz(i)*pss3(i,2)
      dss2(i,6)=ppzaz(i)*pss2(i,3)+wzpz(i)*pss3(i,3)+c(i)

 1009 continue

      do 1010 i=1,nn

      c(i)=half*sss2(i)*zetarec(i)

      psp1(i,1)=wxcx(i)*pss2(i,1)+c(i)
      psp1(i,2)=wycy(i)*pss2(i,1)
      psp1(i,3)=wzcz(i)*pss2(i,1)
      psp1(i,4)=wxcx(i)*pss2(i,2)
      psp1(i,5)=wycy(i)*pss2(i,2)+c(i)
      psp1(i,6)=wzcz(i)*pss2(i,2)
      psp1(i,7)=wxcx(i)*pss2(i,3)
      psp1(i,8)=wycy(i)*pss2(i,3)
      psp1(i,9)=wzcz(i)*pss2(i,3)+c(i)

 1010 continue

      do 1011 j=1,3
      do 1011 i=1,nn
 1011 c1(i,j)=half*pss1(i,j)*zetarec(i)

      do 1012 i=1,nn
      dsp0(i,01)=wxcx(i)*dss1(i,1)+c1(i,1)*two
      dsp0(i,02)=wycy(i)*dss1(i,1)
      dsp0(i,03)=wzcz(i)*dss1(i,1)
      dsp0(i,04)=wxcx(i)*dss1(i,2)+c1(i,2)
      dsp0(i,05)=wycy(i)*dss1(i,2)+c1(i,1)
      dsp0(i,06)=wzcz(i)*dss1(i,2)
      dsp0(i,07)=wxcx(i)*dss1(i,3)+c1(i,3)
      dsp0(i,08)=wycy(i)*dss1(i,3)
      dsp0(i,09)=wzcz(i)*dss1(i,3)+c1(i,1)
      dsp0(i,10)=wxcx(i)*dss1(i,4)
      dsp0(i,11)=wycy(i)*dss1(i,4)+c1(i,2)*two
      dsp0(i,12)=wzcz(i)*dss1(i,4)
      dsp0(i,13)=wxcx(i)*dss1(i,5)
      dsp0(i,14)=wycy(i)*dss1(i,5)+c1(i,3)
      dsp0(i,15)=wzcz(i)*dss1(i,5)+c1(i,2)
      dsp0(i,16)=wxcx(i)*dss1(i,6)
      dsp0(i,17)=wycy(i)*dss1(i,6)
 1012 dsp0(i,18)=wzcz(i)*dss1(i,6)+c1(i,3)*two

      do 1013 j=1,3
      do 1013 i=1,nn
 1013 c1(i,j)=half*pss2(i,j)*zetarec(i)

      do 1014 i=1,nn
      dsp1(i,01)=wxcx(i)*dss2(i,1)+c1(i,1)*two
      dsp1(i,02)=wycy(i)*dss2(i,1)
      dsp1(i,03)=wzcz(i)*dss2(i,1)
      dsp1(i,04)=wxcx(i)*dss2(i,2)+c1(i,2)
      dsp1(i,05)=wycy(i)*dss2(i,2)+c1(i,1)
      dsp1(i,06)=wzcz(i)*dss2(i,2)
      dsp1(i,07)=wxcx(i)*dss2(i,3)+c1(i,3)
      dsp1(i,08)=wycy(i)*dss2(i,3)
      dsp1(i,09)=wzcz(i)*dss2(i,3)+c1(i,1)
      dsp1(i,10)=wxcx(i)*dss2(i,4)
      dsp1(i,11)=wycy(i)*dss2(i,4)+c1(i,2)*two
      dsp1(i,12)=wzcz(i)*dss2(i,4)
      dsp1(i,13)=wxcx(i)*dss2(i,5)
      dsp1(i,14)=wycy(i)*dss2(i,5)+c1(i,3)
      dsp1(i,15)=wzcz(i)*dss2(i,5)+c1(i,2)
      dsp1(i,16)=wxcx(i)*dss2(i,6)
      dsp1(i,17)=wycy(i)*dss2(i,6)
 1014 dsp1(i,18)=wzcz(i)*dss2(i,6)+c1(i,3)*two

      do 1015 j=1,6
      do 1015 i=1,nn
 1015 c2(i,j)=(dss0(i,j)-zetac2(i)*dss1(i,j))/(two*zetaux)

      do 1016 j=1,9
      do 1016 i=1,nn
 1016 c3(i,j)=half*psp1(i,j)*zetarec(i)

      do 1017 i=1,nn
      dsd0(i,01)=wxcx(i)*dsp1(i,01)+c2(i,1)+c3(i,1)*two
      dsd0(i,02)=wycy(i)*dsp1(i,01)
      dsd0(i,03)=wzcz(i)*dsp1(i,01)
      dsd0(i,04)=wycy(i)*dsp1(i,02)+c2(i,1)
      dsd0(i,05)=wzcz(i)*dsp1(i,02)
      dsd0(i,06)=wzcz(i)*dsp1(i,03)+c2(i,1)
      dsd0(i,07)=wxcx(i)*dsp1(i,04)+c2(i,2)+c3(i,4)
      dsd0(i,08)=wycy(i)*dsp1(i,04)        +c3(i,1)
      dsd0(i,09)=wzcz(i)*dsp1(i,04)
      dsd0(i,10)=wycy(i)*dsp1(i,05)+c2(i,2)+c3(i,2)
      dsd0(i,11)=wzcz(i)*dsp1(i,05)
      dsd0(i,12)=wzcz(i)*dsp1(i,06)+c2(i,2)
      dsd0(i,13)=wxcx(i)*dsp1(i,07)+c2(i,3)+c3(i,7)
      dsd0(i,14)=wycy(i)*dsp1(i,07)
      dsd0(i,15)=wzcz(i)*dsp1(i,07)        +c3(i,1)
      dsd0(i,16)=wycy(i)*dsp1(i,08)+c2(i,3)
      dsd0(i,17)=wzcz(i)*dsp1(i,08)        +c3(i,2)
      dsd0(i,18)=wzcz(i)*dsp1(i,09)+c2(i,3)+c3(i,3)
      dsd0(i,19)=wxcx(i)*dsp1(i,10)+c2(i,4)
      dsd0(i,20)=wycy(i)*dsp1(i,10)        +c3(i,4)*two
      dsd0(i,21)=wzcz(i)*dsp1(i,10)
      dsd0(i,22)=wycy(i)*dsp1(i,11)+c2(i,4)+c3(i,5)*two
      dsd0(i,23)=wzcz(i)*dsp1(i,11)
      dsd0(i,24)=wzcz(i)*dsp1(i,12)+c2(i,4)
      dsd0(i,25)=wxcx(i)*dsp1(i,13)+c2(i,5)
      dsd0(i,26)=wycy(i)*dsp1(i,13)        +c3(i,7)
      dsd0(i,27)=wzcz(i)*dsp1(i,13)        +c3(i,4)
      dsd0(i,28)=wycy(i)*dsp1(i,14)+c2(i,5)+c3(i,8)
      dsd0(i,29)=wzcz(i)*dsp1(i,14)        +c3(i,5)
      dsd0(i,30)=wzcz(i)*dsp1(i,15)+c2(i,5)+c3(i,6)
      dsd0(i,31)=wxcx(i)*dsp1(i,16)+c2(i,6)
      dsd0(i,32)=wycy(i)*dsp1(i,16)
      dsd0(i,33)=wzcz(i)*dsp1(i,16)        +c3(i,7)*two
      dsd0(i,34)=wycy(i)*dsp1(i,17)+c2(i,6)
      dsd0(i,35)=wzcz(i)*dsp1(i,17)        +c3(i,8)*two
 1017 dsd0(i,36)=wzcz(i)*dsp1(i,18)+c2(i,6)+c3(i,9)*two

      do 1018 j=1,6
      do 1018 i=1,nn
 1018 gather(iloc(i),j)=gather(iloc(i),j)
     &                 +dss0(i,j)*cdfits
     &                 +dsp0(i,3*(j-1)+1)*cdfitp(1)
     &                 +dsp0(i,3*(j-1)+2)*cdfitp(2)
     &                 +dsp0(i,3*(j-1)+3)*cdfitp(3)
     &                 +dsd0(i,6*(j-1)+1)*cdfitd(1)
     &                 +dsd0(i,6*(j-1)+2)*cdfitd(2)
     &                 +dsd0(i,6*(j-1)+3)*cdfitd(3)
     &                 +dsd0(i,6*(j-1)+4)*cdfitd(4)
     &                 +dsd0(i,6*(j-1)+5)*cdfitd(5)
     &                 +dsd0(i,6*(j-1)+6)*cdfitd(6)

 1001 continue

      do 1019 i=1,n
      do 1019 j=1,6
 1019 fock(inddyy(icontr(i),j))=fock(inddyy(icontr(i),j))+gather(i,j)

      return
      end
