      subroutine farss(m,n,natoms,icontr,inddyy,iloc,itemp,g,coord,
     &                 redfit,fock,zeta,px,py,pz,base,u,zetarec,wxcx,
     &                 wycy,wzcz,sss,sss0,sss1,sss2,ssp,ssp0,ssp1,ssd,
     &                 ssd0,zetac,c,zzeta,ppx,ppy,ppz,gather,extent)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension cdfitp(3),cdfitd(6)

      dimension icontr(*),inddyy(*),iloc(*),itemp(*)

      dimension g(*),coord(3,*),redfit(10,*),fock(*),zeta(*),px(*),
     &          py(*),pz(*),base(*),u(*),zetarec(*),wxcx(*),wycy(*),
     &          wzcz(*),sss(*),sss0(*),sss1(*),sss2(*),ssp(m,*),
     &          ssp0(n,*),ssp1(n,*),ssd(m,*),ssd0(n,*),zetac(*),c(*),
     &          zzeta(*),ppx(*),ppy(*),ppz(*),gather(*),extent(*)

      data one,two,three/1.0d0,2.0d0,3.0d0/
      data four,five,six,seven/4.0d0,5.0d0,6.0d0,7.0d0/
      data zero,half,thrhlf,pi/0.0d0,0.5d0,1.5d0,3.1415926535898d0/
      data calcut/1.0d-16/
      data rmultipole,onethousand/16.7d0,1000.0d0/
      data cs,cp,cd/1130.5901d0,123849.94d0,10112305.0d0/

      twoecnst=two*pi**(five/two)

      sqrt3=sqrt(three)

      dnormcd=seven/sqrt3

      do 1001 iatom=1,natoms

      ccx=coord(1,iatom)
      ccy=coord(2,iatom)
      ccz=coord(3,iatom)

      zetaux=onethousand

      cdfits=redfit(01,iatom)*cs

      cdfitp(1)=redfit(02,iatom)*cp
      cdfitp(2)=redfit(03,iatom)*cp
      cdfitp(3)=redfit(04,iatom)*cp

      cdfitd(1)=redfit(05,iatom)*cd/dnormcd
      cdfitd(2)=redfit(06,iatom)*cd
      cdfitd(3)=redfit(07,iatom)*cd
      cdfitd(4)=redfit(08,iatom)*cd/dnormcd
      cdfitd(5)=redfit(09,iatom)*cd
      cdfitd(6)=redfit(10,iatom)*cd/dnormcd

      nn=0

      do 1002 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
      pc=pxcx*pxcx+pycy*pycy+pzcz*pzcz
      if(extent(i).le.pc) then
                                 nn=nn+1

                                 zetarec(nn)=one/(zeta(i)+zetaux)

                                 u(nn)=zetaux*zetarec(nn)*zeta(i)*pc

                                 iloc(nn)=i

                                 zzeta(nn)=zeta(i)

                                 ppx(nn)=px(i)
                                 ppy(nn)=py(i)
                                 ppz(nn)=pz(i)
                          endif
 1002 continue

      if(nn.eq.0) goto 1001

      call auggnew(3,nn,n,itemp,u,ssp0,wxcx,wycy,wzcz)

      factor=twoecnst/zetaux

      do 1003 i=1,nn
 1003 c(i)=base(iloc(i))*factor*sqrt(zetarec(i))/zzeta(i)

      do 1004 i=1,nn
      sss0(i)=c(i)*ssp0(i,1)
      sss1(i)=c(i)*ssp0(i,2)
 1004 sss2(i)=c(i)*ssp0(i,3)

      do 1005 i=1,nn
 1005 zetac(i)=zzeta(i)*zetarec(i)

      do 1006 i=1,nn
      wxcx(i)=((zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i))-ccx
      wycy(i)=((zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i))-ccy
 1006 wzcz(i)=((zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i))-ccz

      do 1007 i=1,nn

      ssp0(i,1)=wxcx(i)*sss1(i)
      ssp0(i,2)=wycy(i)*sss1(i)
      ssp0(i,3)=wzcz(i)*sss1(i)

      ssp1(i,1)=wxcx(i)*sss2(i)
      ssp1(i,2)=wycy(i)*sss2(i)
      ssp1(i,3)=wzcz(i)*sss2(i)

 1007 continue

      do 1008 i=1,nn

      c(i)=(sss0(i)-zetac(i)*sss1(i))/(two*zetaux)

      ssd0(i,1)=wxcx(i)*ssp1(i,1)+c(i)
      ssd0(i,2)=wycy(i)*ssp1(i,1)
      ssd0(i,3)=wzcz(i)*ssp1(i,1)
      ssd0(i,4)=wycy(i)*ssp1(i,2)+c(i)
      ssd0(i,5)=wzcz(i)*ssp1(i,2)
      ssd0(i,6)=wzcz(i)*ssp1(i,3)+c(i)

 1008 continue

      do 1009 i=1,nn
 1009 gather(iloc(i))=gather(iloc(i))
     &               +sss0(i)*cdfits
     &               +ssp0(i,1)*cdfitp(1)
     &               +ssp0(i,2)*cdfitp(2)
     &               +ssp0(i,3)*cdfitp(3)
     &               +ssd0(i,1)*cdfitd(1)
     &               +ssd0(i,2)*cdfitd(2)
     &               +ssd0(i,3)*cdfitd(3)
     &               +ssd0(i,4)*cdfitd(4)
     &               +ssd0(i,5)*cdfitd(5)
     &               +ssd0(i,6)*cdfitd(6)

 1001 continue

      do 1010 i=1,n
 1010 fock(inddyy(icontr(i)))=fock(inddyy(icontr(i)))+gather(i)

      return
      end
